unit filedrop;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI;


//Cxgnȟ^錾
type TDropFilesEvent = procedure (X,Y:Integer; fnames:TStrings) of object;


//R|[lg̍q
type TFileDrop = class(TComponent)
  private
    FEnabled:Boolean;
    FOnDropFiles:TDropFilesEvent;
		FWnd:		Hwnd;
		NewP:		TFarProc;
		OldP:		TFarProc;
    procedure setEnabled(v:Boolean);
  protected
		procedure WndProc(var Msg: TMessage);
		procedure Loaded; override;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
  published
    property Enabled:Boolean read FEnabled write SetEnabled;
    property OnDropFiles:TDropFilesEvent read FOnDropFiles write FOnDropFiles;
end;

procedure Register;

implementation


(****************************************************************************
  o^
 ****************************************************************************)
procedure Register;
begin
  RegisterComponents('Samples',[TFileDrop]);
end;

(****************************************************************************
  FileDropR|[lg
 ****************************************************************************)

//RXgN^
constructor TFileDrop.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  if not (csDesigning in ComponentState) then begin
    //I[i[̃EBhEvVW
  	Fwnd:=TForm(AOwner).Handle;
  	NewP:=MakeObjectInstance(WndProc);
  	OldP:=Pointer(SetWindowLong(Fwnd, GWL_WNDPROC, Longint(NewP)));
  end;
end;


//fXgN^
destructor TFileDrop.Destroy;
begin
  //I[i[̃EBhEvVWԂ
	SetWindowLong(Fwnd, GWL_WNDPROC, Longint(OldP));
	FreeObjectInstance(NewP);
  inherited Destroy;
end;

//vpeB̒l
procedure TFileDrop.Loaded;
begin
  Enabled:=FEnabled;
end;

//EnabledvpeB̃Zbg
procedure TFileDrop.setEnabled(v:Boolean);
begin
  FEnabled:=v;
  DragAcceptFiles(Fwnd,v);
end;

//肵I[i[̃tBhEvVW
procedure TFileDrop.WndProc(var Msg: TMessage);
var
  hDrop:THandle;
  dropPoint:TPoint; //hbvꂽʒu
  fnames:TStrings;  //t@CXg
  nDropped:Integer; //hbvꂽ
  fn:Array[0..MAX_PATH] of Char;  //t@C
  i:Cardinal;
begin
	case Msg.Msg of
  	WM_DROPFILES: begin
      //hbv̎擾
      hDrop:=Msg.wParam;
      DragQueryPoint(hDrop,dropPoint);
      nDropped:=DragQueryFile(hDrop,$FFFFFFFF,Nil,0);
      //t@C̍\z
      fnames:=TStringlist.Create;
      For i:=0 to nDropped-1 do begin
        DragQueryFile(hDrop,i,fn,MAX_PATH);
        fnames.Add(StrPas(fn));
      end;
      DragFinish(hDrop);
      //CxgnhĂ
      if Assigned(FOnDropFiles) then
        FOnDropFiles(dropPoint.X, dropPoint.Y, fnames);
      //fnames̉
      if Assigned(fnames) then
        fnames.Free;
    end;
  end;
	Msg.Result:=CallWindowProc(OldP, Fwnd, Msg.Msg, Msg.wParam, Msg.lParam);
end;

end.
