unit toPNGmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,s_util,GLDPNG, StdCtrls, filedrop, Menus, INIFiles;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    FileDrop1: TFileDrop;
    MainMenu1: TMainMenu;
    ool1: TMenuItem;
    O1: TMenuItem;
    N2e1: TMenuItem;
    Exit1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FileDrop1DropFiles(X, Y: Integer; fnames: TStrings);
    procedure Exit1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure LoadFromINI;
    procedure SaveToINI;
  public
    { Public 錾 }
    ININame:String;
    procedure StartUp;
  end;

  TConverterThread = class(TThread)
  private
    FBmpName,FPngName:String;
    FFilter:TGLDPNGFilterType;
    FCompLevel:Integer;
    FInterlace:TGLDPNGInterlaceType;
    FAdjustTimestamp:Boolean;
  public
    constructor Create(bmpName,pngName:String; filter:TGLDPNGFilterType; compLevel:Integer; interlace:TGLDPNGInterlaceType; adjustTS:Boolean);
    procedure Execute; override;
  end;

var
  Form1: TForm1;

implementation

uses toPngOption;

{$R *.dfm}

procedure TForm1.StartUp;
begin
  ININame:=ChangeFileExt(Application.ExeName,'.ini');
  SUT_LoadFormPos(ININame, 'desktop', self);
  SUT_RegulateFormPos(self);
  LoadFromINI;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SUT_SaveFormPos(ININame, 'desktop', self);
end;

procedure TForm1.FileDrop1DropFiles(X, Y: Integer; fnames: TStrings);
var
  i:Integer;
  bmpName,pngName:String;
  threadCount:Integer;
  converter:Array of TConverterThread;
  t1,t2:TDateTime;
  srcFiles:TStrings;

  filter:TGLDPNGFilterType;
  compLevel:Integer;
  interlace:TGLDPNGInterlaceType;
  adjustTS:Boolean;

  //TXyhĂXbhTāAꖇ̉摜ϊ
  procedure CreateNewThread(idx:Integer);
  var
    i:Integer;
  begin
    while True do begin

      for i:=0 to threadCount-1 do begin
        //XbhSĖȂAĊJn
        if not Assigned(converter[i]) then begin
          Memo1.Lines.Add(Format('ϊJn#%d/%d : %s -> %s',[idx+1,srcFiles.Count,bmpName,pngName]));
          converter[i]:=TConverterThread.Create(bmpName,pngName,filter,compLevel,interlace,adjustTS);
          exit;
        end;
      end;

      //TXyhĂXbhT
      for i:=0 to threadCount-1 do begin
        if converter[i].Terminated then begin
          Memo1.Lines.Add(Format('ϊJn#%d/%d : %s -> %s',[idx+1,srcFiles.Count,bmpName,pngName]));
          converter[i].Free;
          converter[i]:=TConverterThread.Create(bmpName,pngName,filter,compLevel,interlace,adjustTS);
          exit;
        end;
      end;

      //҂
      Sleep(50);
      Application.ProcessMessages;

    end;
  end;
begin
  //ݒǂݍ
  case Form2.RadioGroupCompressLevel.ItemIndex of
    0:compLevel:=gplSpeed;
    1:compLevel:=gplDefault;
    2:compLevel:=gplBest;
  end;
  filter:=TGLDPNGFilterType(Form2.RadioGroupFilter.ItemIndex);
  interlace:=TGLDPNGInterlaceType(Form2.RadioGroupInterlace.ItemIndex);
  adjustTS:=Form2.CheckBoxAdjustTimeStamp.Checked;

  threadCount:=1;

  srcFiles:=TStringList.Create;
  For i:=0 to fnames.Count-1 do begin
    if AnsiUpperCase(ExtractFileExt(fnames[i])) = '.BMP' then begin
      srcFiles.Add(fnames[i]);
    end;
  end;

  if srcFiles.Count = 0 then begin
    MessageDlg('BMPt@Cw肳Ă܂',mtWarning, [mbOK], 0);
    srcFiles.Free;
    exit;
  end;

  //t@Cw肳ꂽ
  if srcFiles.Count > 1 then begin
    if MessageDlg(Format('%dBMPt@Cw肳܂As܂H',
      [srcFiles.Count]),mtConfirmation, [mbYes,mbNo], 0) = mrNo then begin
      srcFiles.Free;
      exit;
    end;
    if MessageDlg('2摜ϊ܂H(}`vZbTŐ)',
      mtConfirmation, [mbYes,mbNo],0) = mrYes then
      threadCount:=2
    else
      threadCount:=1;
  end;


  SetLength(converter, threadCount);
  for i:=0 to threadCount-1 do
    converter[i]:=Nil;

  t1:=Now;
  Screen.Cursor:=crHourGlass;
  for i:=0 to srcFiles.Count-1 do begin
    bmpName:=srcFiles[i];
    pngName:=ChangeFileExt(srcFiles[i],'.png');
    CreateNewThread(i);
  end;

  //Еt
  for i:=0 to threadCount-1 do begin
    if Assigned(converter[i]) then begin
      converter[i].WaitFor;
      converter[i].Free;
    end;
  end;

  t2:=Now;
  Memo1.Lines.Add(Format('ϊI܂ v:%.2fb',[(t2-t1)*86400.0]));

  converter:=Nil;
  srcFiles.Free;

  Screen.Cursor:=crDefault;
end;

{ TConverterThread }

constructor TConverterThread.Create(bmpName,pngName:String; filter:TGLDPNGFilterType; compLevel:Integer; interlace:TGLDPNGInterlaceType; adjustTS:Boolean);
begin
  inherited Create(False);

  FBmpName:=bmpName;
  FPngName:=pngName;

  FFilter:=filter;
  FCompLevel:=compLevel;
  FInterlace:=interlace;
  FAdjustTimestamp:=adjustTS;
end;

procedure TConverterThread.Execute;
var
  png:TGLDPNG;
  bmp:TBitmap;
begin
  inherited;

  bmp:=TBitmap.Create;
  png:=TGLDPNG.Create;

  png.FilterType:=FFilter;
  png.CompressLevel:=FCompLevel;
  png.InterlaceType:=FInterlace;
  try
    bmp.LoadFromFile(FBmpName);
    png.Assign(bmp);
    png.SaveToFile(FPngName);
    //t킹
    if FAdjustTimestamp then begin
      FileSetDate(FPngName,FileAge(FBmpName));
    end;
  finally
    bmp.Free;
    png.Free;
    Terminate;
  end;

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.LoadFromINI;
var
  ini:TINIFile;
begin
  ini:=TINIFile.Create(ININame);
  Form2.RadioGroupFilter.ItemIndex:=ini.ReadInteger('option', 'Filter', 0);
  Form2.RadioGroupCompressLevel.ItemIndex:=ini.ReadInteger('option','CompressLevel', 2);
  Form2.RadioGroupInterlace.ItemIndex:=ini.ReadInteger('option','InterlaceType', 0);
  Form2.CheckBoxAdjustTimeStamp.Checked:=ini.ReadBool('option', 'AdjustTimeStamp', True);
  ini.Free;
end;

procedure TForm1.SaveToINI;
var
  ini:TINIFile;
begin
  ini:=TINIFile.Create(ININame);
  ini.writeInteger('option', 'Filter', Form2.RadioGroupFilter.ItemIndex);
  ini.writeInteger('option','CompressLevel', Form2.RadioGroupCompressLevel.ItemIndex);
  ini.writeBool('option', 'AdjustTimeStamp', Form2.CheckBoxAdjustTimeStamp.Checked);
  ini.ReadInteger('option','InterlaceType', Form2.RadioGroupInterlace.ItemIndex);
  ini.Free;
end;


procedure TForm1.O1Click(Sender: TObject);
begin
  LoadFromINI;
  if Form2.ShowModal = mrOK then
    SaveToINI;
end;

end.
